#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
Ãditeur de Spyder

Ceci est un script temporaire.
"""

# Copyright Gilles Muller, 2018

import xlsxwriter
from xlsxwriter.utility import xl_rowcol_to_cell

# definition des colones
C_Time = 0
C_UniCapa = 1
C_ScCapa = 2
C_UniVolt = 3
C_ScVolt = 4
C_UniAmp = 5
C_ScAmp = 6
C_UniAlti = 7
C_ScRPM = 8
C_Dt = 9
C_UniW = 10
C_UniEnergie = 11
C_ScW = 12
C_ScEnergie = 13
C_UniAltiFin = 14
C_TpsDeb = 14
C_UniCapaFin = 15
C_TpsMont = 16
C_UniEnergieTot = 17
C_UniTxMont = 18
C_UniEM = 19


def Header(worksheet):

# Write some data headers.
    worksheet.set_row(0, 25)
    worksheet.write(0, C_Time, 'Time (s)', HeadMes)

    worksheet.write(0, C_UniCapa, 'Uni\nCapacite(ma)', HeadMes)
    worksheet.write(0, C_ScCapa, 'Scorpion\nCapacite(ma)', HeadMesSc)
    worksheet.write(0, C_UniVolt, 'Uni\nTension(V)', HeadMes)
    worksheet.write(0, C_ScVolt, 'Scorpion\nTension(V)', HeadMesSc)
    worksheet.write(0, C_UniAmp, 'Uni\nAmperage(A)', HeadMes)
    worksheet.write(0, C_ScAmp, 'Scorpion\nAmperage(A)', HeadMesSc)

    worksheet.write(0, C_UniAlti, 'Uni\nAltitude(m)', HeadMes)
    worksheet.write(0, C_ScRPM, 'Scorpion\nRPM(t/min)', HeadMesSc)
    worksheet.write(0, C_Dt, 'dt(s)', HeadMes)
    worksheet.write(0, C_UniW, 'Uni\nW', HeadMes)
    worksheet.write(0, C_UniEnergie, 'Uni\nWh', HeadMes)
    worksheet.set_column(0, C_UniEnergie, 12)
    worksheet.write(0, C_ScW, 'Scorpion\nW', HeadMesSc)
    worksheet.write(0, C_ScEnergie, 'Scorpion\nWh', HeadMesSc)
    worksheet.set_column(0, C_UniEnergie, 12)

    worksheet.write(0, C_UniAltiFin, 'Alti finale(m)', HeadRes)
    worksheet.write(3, C_TpsDeb, 'Tps Debut', HeadRes)
    worksheet.set_column(C_UniAltiFin, C_UniAltiFin, 14)
    
    worksheet.write(0, C_UniCapaFin, 'Capacite (ma)\nUni', HeadRes)
    worksheet.write(3, C_UniCapaFin, 'Scorpion', HeadRes)
    worksheet.set_column(C_UniCapaFin, C_UniCapaFin, 14)
    
    worksheet.write(0, C_TpsMont, 'Duree montee(s)', HeadRes)
    worksheet.set_column(C_TpsMont, C_TpsMont, 15)
    worksheet.write(0, C_UniEnergieTot, 'Energie(Wh)\nUni', HeadRes)
    worksheet.write(3, C_UniEnergieTot, 'Scorpion', HeadRes)
   
    worksheet.set_column(C_UniEnergieTot, C_UniEnergieTot, 14)
    worksheet.write(0, C_UniTxMont, 'Taux de montee', HeadRes)
    worksheet.set_column(C_UniTxMont, C_UniTxMont, 15)
    worksheet.write(0, C_UniEM, 'E/m\nUni', HeadRes)
    worksheet.write(3, C_UniEM, 'Scorpion', HeadRes)

    return;

def Afftime(time):
    
    st = str(time/(60*1000)) + ':' + str((time%(60*1000)/1000))
    
    return st;

MotOff = 0
MotOn = 1
MotDesc = 2


workbook = xlsxwriter.Workbook('analyse.xlsx')

# Add a bold format to use to highlight cells.
HeadMes = workbook.add_format({'bold': True})
HeadMes.set_align('center')
HeadMes.set_bg_color('gray')

HeadMesSc = workbook.add_format({'bold': True})
HeadMesSc.set_align('center')
HeadMesSc.set_bg_color('lime')


HeadRes = workbook.add_format({'bold': True})
HeadRes.set_align('center')
HeadRes.set_bg_color('yellow')

formatN0 = workbook.add_format()
formatN0.set_num_format('0')

formatN1 = workbook.add_format()
formatN1.set_num_format('0.0')

formatN4 = workbook.add_format()
formatN4.set_num_format('0.0000')

formatN6 = workbook.add_format()
formatN6.set_num_format('0.000000')

formatN4G = workbook.add_format()
formatN4G.set_num_format('0.0000')
formatN4G.set_bg_color('green')

formatSec = workbook.add_format()
formatSec.set_num_format('0.00')

formatTime = workbook.add_format()
formatTime.set_num_format('hh:mm:ss')


State = MotOff
InitTime = True
ZeroSample = 0


#       worksheet.write_formula(row, 1, '=SUM(B2:B5)', money)


# Iterate over the data and write it out row by row.
#for item, cost in (expenses):
#   worksheet.write(row, col,     item)
#    worksheet.write(row, col + 1, cost, money)
#    row += 1


file = open('test.log', 'r') 
header = file.readline();

i = 0
headers = []
words = file.readline().split(';')
headers.extend([words])
print headers[i]

# look for Unisens
while words[0] == '000000000':
   i += 1
   words = file.readline().split(';')
   if words[0] == '000000000' :
       headers.extend([words])
       print headers[i]
       if words[3] == 'UniS-E' :
           UniS = words[1]           
       if words[3] == 'Scorpion ESC' :
           Scorp = words[1]           
       if words[3] == 'MVARIO' :
           MVario = words[1]           

print '--------'

PrevTimeStamp = -1
row = 1

Amps = 0
Volt = 0
Capa = 0
Alti = 0
ScCapa = 0
ScRPM = 0
ScAmps = 0
ScVolt = 0
MVAlti = 0

P_Capa = 0
P_ScCapa = 0
P_Volt = 0
P_ScVolt = 0
P_Amps = 0
P_ScAmps = 0
P_Alti =  0
P_ScRPM = 0
P_MVAlti = 0

#first sheet
worksheet = workbook.add_worksheet()
row = 1
Header(worksheet)


# fill spreadsheet
for line in file:
   words = line.split(';')
       
   TimeStamp = int(words[0]);
   if InitTime ==  True:
           InitTime = False
           ZeroSample = TimeStamp
           TimeStamp = 0
   else:
           TimeStamp -= ZeroSample
           
#   if (words[1] == UniS) or (words[1] == Scorp):

   #Unisens-E
   if words[1] == UniS :
   #enleve entete
       del words[0]
       del words[0]

   #decodage de la ligne       
       while len(words) > 0:
         
       #Volts
           if words[0] == '1':
               Volt = float(words[3])/(10 ** int(words[2]))

       #Amps
           if words[0] == '2':
               if int(words[3]) < 2147483647:  # positif
                   Amps = float(words[3])/(10 ** int(words[2]))
               else:
                   Amps = - (~(int(words[3])-1) & 4294967295)
                   Amps = float(Amps) / (10 ** int(words[2]))
                      
       #capa
           if words[0] == '3':
               Capa = int(words[3])

       #Altitude
           if words[0] == '5':
               if int(words[3]) < 2147483647:  # positif
                   Alti = float(words[3])/(10 ** int(words[2]))
               else:
                   Alti = - (~(int(words[3])-1) & 4294967295)
                   Alti = float(Alti) / (10 ** int(words[2]))
       # destruction de la mesure courante 
           del words[0]
           del words[0]
           del words[0]
           del words[0]
                 
   else: # Scorpion  
        if (words[1] == Scorp) :      
   #enleve entete
            del words[0]
            del words[0]

   #decodage de la ligne       
            while len(words) > 0:

       #capa
               if words[0] == '7':   ScCapa = int(words[3])
       #RPM
               if words[0] == '8':   ScRPM = int(words[3])/7
       #Amps
               if words[0] == '2':
                   if int(words[3]) < 2147483647:  # positif
                       ScAmps = float(words[3])/(10 ** int(words[2]))
                   else:
                       ScAmps = - (~(int(words[3])-1) & 4294967295)
                       ScAmps = float(ScAmps) / (10 ** int(words[2]))
       #Volts
               if words[0] == '1':
                   ScVolt = float(words[3])/(10 ** int(words[2]))

       # destruction de la mesure courante 
               del words[0]
               del words[0]
               del words[0]
               del words[0]
               
        else:   # MVario
          if (words[1] == MVario) :      
   #enleve entete
            del words[0]
            del words[0]

   #decodage de la ligne       
            while len(words) > 0:

       #Altitude
               if words[0] == '3':
                   if int(words[3]) < 2147483647:  # positif
                       MVAlti = float(words[3])/(10 ** int(words[2]))
               else:
                       MVAlti = - (~(int(words[3])-1) & 4294967295)
                       MVAlti = float(Alti) / (10 ** int(words[2]))
       # destruction de la mesure courante 
               del words[0]
               del words[0]
               del words[0]
               del words[0]


   if State == MotOn:                 
#           if TimeStamp != PrevTimeStamp:
#               PrevTimeStamp = TimeStamp
                              
               # Generation d'une ligne que si valeurs differentes
               if (Capa != P_Capa) or (ScCapa != P_ScCapa) or (Volt != P_Volt) or (ScVolt != P_ScVolt) or (Amps != P_Amps) or (ScAmps != P_ScAmps) or (Alti !=  P_Alti) or (ScRPM != P_ScRPM):
              
                 PrevTimeStamp = TimeStamp
                 P_Capa = Capa
                 P_ScCapa = ScCapa
                 P_Volt = Volt
                 P_ScVolt = ScVolt
                 P_Amps = Amps
                 P_ScAmps = ScAmps
                 P_Alti =  Alti
                 P_ScRPM = ScRPM
               
                 worksheet.write(row, C_Time, float (TimeStamp-TimeDeb)/1000, formatSec)
                 worksheet.write(row, C_UniCapa, Capa)
                 worksheet.write(row, C_ScCapa, ScCapa)
                 worksheet.write(row, C_UniVolt, Volt)
                 worksheet.write(row, C_ScVolt, ScVolt)
                 worksheet.write(row, C_UniAmp, Amps)
                 worksheet.write(row, C_ScAmp, ScAmps)
                 worksheet.write(row, C_UniAlti, Alti)
                 worksheet.write(row, C_ScRPM, ScRPM)

                 if row != 1:
                   worksheet.write_formula(row, C_Dt, '=('+xl_rowcol_to_cell(row, C_Time)+'-'+xl_rowcol_to_cell(row-1, C_Time)+')', formatN4)
                   worksheet.write_formula(row, C_UniW, '='+xl_rowcol_to_cell(row, C_UniVolt)+'*'+xl_rowcol_to_cell(row, C_UniAmp), formatN0)
                   worksheet.write_formula(row, C_UniEnergie, '='+xl_rowcol_to_cell(row-1, C_UniEnergie)+'+'+xl_rowcol_to_cell(row, C_Dt)+
                                                     '*'+xl_rowcol_to_cell(row, C_UniW)+'/3600', formatN4)
                                                     
                   worksheet.write_formula(row, C_ScW, '='+xl_rowcol_to_cell(row, C_ScVolt)+'*'+xl_rowcol_to_cell(row, C_ScAmp), formatN0)
                   worksheet.write_formula(row, C_ScEnergie, '='+xl_rowcol_to_cell(row-1, C_ScEnergie)+'+'+xl_rowcol_to_cell(row, C_Dt)+
                                                     '*'+xl_rowcol_to_cell(row, C_ScW)+'/3600', formatN4)           
                 row +=1

     #Automate de detection des remorquages
   if State == MotOff: 
           if (Amps > 0.5):   # remise des gaz au sol
               State = MotOn
               TimeDeb = TimeStamp
               print 'MotOn', Afftime(TimeStamp), 'Amps:', Amps, 'Alti', Alti, 'Capa', Capa
    

   if State == MotDesc:
         if (ScRPM == 0):
                   State = MotOff
                   print 'MotOff', Afftime(TimeStamp), 'Amps:', Amps, 'Alti', Alti, MVAlti
                   print
    
     # valeurs finales    
   if State == MotOn and Amps <= 0:
        print 'MotDesc', Afftime(TimeStamp), 'Amps:', Amps, 'Alti', Alti, MVAlti, 'Capa', Capa
        State = MotDesc
        if (Alti > 100):
           worksheet.write_formula(4, C_TpsDeb, '='+str(TimeDeb)+'/(1000*24*3600)', formatTime)    #Temps debut        
         
           worksheet.write_formula(1, C_UniAltiFin, '='+xl_rowcol_to_cell(row-1, C_UniAlti), formatN0)              #altitude
           worksheet.write_formula(1, C_UniCapaFin, '='+xl_rowcol_to_cell(row-1, C_UniCapa)+'-'+xl_rowcol_to_cell(1, C_UniCapa), formatN0)                       # capacite
           worksheet.write_formula(4, C_UniCapaFin, '='+xl_rowcol_to_cell(row-1, C_ScCapa)+'-'+xl_rowcol_to_cell(1, C_ScCapa), formatN0)                     # capacite
           worksheet.write_formula(1, C_TpsMont, '='+xl_rowcol_to_cell(row-1, C_Time), formatN1)                             # duree

#           worksheet.write_formula(1, c, '=I'+str(row), formatSec)     ; c+=1                        # Energie
           worksheet.write_formula(1, C_UniEnergieTot, '='+xl_rowcol_to_cell(row-1, C_UniEnergie), formatSec)                                  # Energie
           worksheet.write_formula(4, C_UniEnergieTot, '='+xl_rowcol_to_cell(row-1, C_ScEnergie), formatSec)                                  # Energie


#           worksheet.write_formula(1, c, '=J2/L2', formatSec)          ; c+=1                        # Taux de montee
           worksheet.write_formula(1, C_UniTxMont, '='+xl_rowcol_to_cell(1, C_UniAltiFin)+'/'+xl_rowcol_to_cell(1, C_TpsMont), formatSec)      # Taux de montee
#           worksheet.write_formula(1, c, '=M2/J2', formatN4G)          ; c+=1                        # Energie/m
           worksheet.write_formula(1, C_UniEM, '='+xl_rowcol_to_cell(1, C_UniEnergieTot)+'/'+xl_rowcol_to_cell(1, C_UniAltiFin), formatN4G)    # Energie/m
           worksheet.write_formula(4, C_UniEM, '='+xl_rowcol_to_cell(4, C_UniEnergieTot)+'/'+xl_rowcol_to_cell(1, C_UniAltiFin), formatN4G)    # Energie/m

           worksheet.freeze_panes(1, 0)
           worksheet = workbook.add_worksheet()
           row = 1
           Header(worksheet)
        else:           
           print 'Cancelled'
           row = 1

  


workbook.close()
file.close()